#include <iostream>
//#include <iomanip>
//#include <cmath>
//#include <algorithm>
//#include <string>
//#include <vector>
//#include <ctime>
//#include <cstdlib>
//#include <limits>
//#include <mycpp.h>

using namespace std;

void Izmeni(int *a,int n,int l,int r)
{
	for(int i=l;i<r;i++)
		*(a+i)=1-*(a+i);
}

bool Isto(int a[],int n,int k)
{
	for(int i=0;i<n;i++)
		if(a[i]==k)
			return false;
	return true;
}

int Cena(int a[],int n,int c)
{
	int minC=0;
	for(int i=0;i<n;i++)
	if(a[i]==1)
		minC++;
	for(int i=0;i<n-1;i++)
	{
		for(int j=0;j<n;j++)
		{
			int b[n],br=0;
			for(int k=0;k<n;k++)
			{
				b[k]=a[k];
				if(a[k]==1)
					br++;
			}
			minC=min(minC,br);
			Izmeni(b,n,i,j);
			if(Isto(a,n,1))
				return c+min(n,c);
			else if(Isto(a,n,0))
				return c;
			br=c;
			for(int k=0;k<n;k++)
				if(b[k]==1)
					br++;
			minC=min(minC,br);
		}
	}
	return minC;
}

int main()
{
	int n,c,q;
	cin>>n>>c>>q;
	string s;
	cin>>s;
	int a[n];
	for(int i=0;i<n;i++)
		a[i]=s[i]-'0';
	for(int i=0;i<n;i++)
	{
		int l,r;
		cin>>l>>r;
		Izmeni(a,n,l-1,r-1);
		if(Isto(a,n,1))
			cout<<min(n,c)<<endl;
		else if(Isto(a,n,0))
			cout<<0<<endl;
		else
			cout<<Cena(a,n,c)<<endl;	
	}
}